// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'FileStorage.pas' rev: 3.00

#ifndef FileStorageHPP
#define FileStorageHPP
#include <Classes.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Filestorage
{
//-- type declarations -------------------------------------------------------
typedef TList TStoredFiles;
;

class DELPHICLASS TStoredFile;
class DELPHICLASS TFileStorage;
class DELPHICLASS TAutoExtract;
class DELPHICLASS TExtractTo;
enum TToplevelDir { tdCurrentDir, tdWindowsDir, tdTempDir, tdSystemDir, tdMediaDir, tdCursorsDir, tdHelpDir, 
	tdSamplesDir, tdDesktop, tdProgramFiles, tdMyDocuments, tdMyPictures, tdAppData, tdNone };

class PASCALIMPLEMENTATION TExtractTo : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FCreatePath;
	TToplevelDir FToplevelDir;
	System::AnsiString FSubdirectory;
	
public:
	System::AnsiString __fastcall Path();
	
__published:
	__property bool CreatePath = {read=FCreatePath, write=FCreatePath, default=1};
	__property TToplevelDir ToplevelDir = {read=FToplevelDir, write=FToplevelDir, default=0};
	__property System::AnsiString Subdirectory = {read=FSubdirectory, write=FSubdirectory};
public:
	/* TPersistent.Destroy */ __fastcall virtual ~TExtractTo(void) { }
	
public:
	/* TObject.Create */ __fastcall TExtractTo(void) : Classes::TPersistent() { }
	
};

enum TFileStorageOverwrite { owIfSizeDifferent, owNever, owAlways };

class PASCALIMPLEMENTATION TAutoExtract : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	bool FEnabled;
	TExtractTo* FExtractTo;
	TFileStorageOverwrite FOverwrite;
	bool FRemoveOnTerminate;
	
public:
	__fastcall TAutoExtract(void);
	__fastcall virtual ~TAutoExtract(void);
	
__published:
	__property bool Enabled = {read=FEnabled, write=FEnabled, default=0};
	__property TExtractTo* ExtractTo = {read=FExtractTo, write=FExtractTo};
	__property TFileStorageOverwrite Overwrite = {read=FOverwrite, write=FOverwrite, default=0};
	__property bool RemoveOnTerminate = {read=FRemoveOnTerminate, write=FRemoveOnTerminate, default=0};
		
};

typedef void __fastcall (__closure *TOnExtractEvent)(System::TObject* Sender, System::AnsiString FileName
	, int FileSize, bool &AllowExtracting);

typedef void __fastcall (__closure *TOnExtractedEvent)(System::TObject* Sender, System::AnsiString FileName
	, int FileSize, bool Successfully);

class PASCALIMPLEMENTATION TFileStorage : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TAutoExtract* FAutoExtract;
	Classes::TList* FFiles;
	Classes::TStringList* ExtractedFilesList;
	TOnExtractEvent FOnExtract;
	TOnExtractedEvent FOnExtracted;
	bool Compressed;
	int __fastcall GetDataSize(void);
	void __fastcall SetNone(const int Value);
	void __fastcall ReadData(Classes::TStream* Stream);
	void __fastcall WriteData(Classes::TStream* Stream);
	
protected:
	virtual void __fastcall Loaded(void);
	virtual void __fastcall DefineProperties(Classes::TFiler* Filer);
	
public:
	int FCount;
	__fastcall virtual TFileStorage(Classes::TComponent* aOwner);
	__fastcall virtual ~TFileStorage(void);
	bool __fastcall Extract(const System::AnsiString FileName, System::AnsiString OutputFile);
	
__published:
	__property TAutoExtract* AutoExtract = {read=FAutoExtract, write=FAutoExtract};
	__property int Count = {read=FCount, write=SetNone, stored=false, nodefault};
	__property int DataSize = {read=GetDataSize, write=SetNone, stored=false, nodefault};
	__property Classes::TList* Files = {read=FFiles, write=FFiles, stored=false};
	__property TOnExtractEvent OnExtract = {read=FOnExtract, write=FOnExtract};
	__property TOnExtractedEvent OnExtracted = {read=FOnExtracted, write=FOnExtracted};
};

class PASCALIMPLEMENTATION TStoredFile : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	TFileStorage* FOwner;
	System::AnsiString FFileName;
	int FSize;
	Classes::TMemoryStream* FData;
	virtual bool __fastcall Extract(const System::AnsiString FileName, bool CreatePath);
	
public:
	__fastcall TStoredFile(TFileStorage* aOwner);
	__fastcall virtual ~TStoredFile(void);
	void __fastcall ReadData(Classes::TStream* Stream);
	void __fastcall WriteData(Classes::TStream* Stream);
	bool __fastcall Upload(const System::AnsiString FileName);
	void __fastcall ClearData(void);
	__property System::AnsiString FileName = {read=FFileName, write=FFileName};
	__property int Size = {read=FSize, write=FSize, nodefault};
	__property Classes::TMemoryStream* Data = {read=FData, write=FData};
};

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Filestorage */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Filestorage;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// FileStorage
